package edu.washington.cs.oneswarm.ui.gwt.client.newui;

import com.google.gwt.widgetideas.client.ProgressBar;
import com.google.gwt.widgetideas.client.ProgressBar.TextFormatter;

import edu.washington.cs.oneswarm.ui.gwt.rpc.StringTools;
import edu.washington.cs.oneswarm.ui.gwt.rpc.TorrentInfo;

public class SwarmRateTextFormatter extends TextFormatter {
	
	TorrentInfo swarm;
	
	public SwarmRateTextFormatter( TorrentInfo swarm ) {
		this.swarm = swarm;
	}
	
	protected String getText(ProgressBar bar, double curProgress) {
		if( swarm.isStarted() ) {
			// * 1024 since these are denominated in KBps
			return (int) (100 * bar.getPercent()) + "%" + " (" + StringTools.formatRate( (int) swarm.getDownloadRate()*1024) + "/s)";
		} else {
			return (int) (100 * bar.getPercent()) + "%" + " (stopped)";							
		}
	}
}
